gaphor/venv

107 lines
2.7 KiB
Bash
Executable File

#!/bin/bash
#
# An easy way to set up a virtualenv.
#
# Source this file to work inside this venv:
#
# source ./venv [-f]
#
# Call `./venv -f` to force a new development installation.
#
SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
# If on Macos with brew, make sure we can find the brewed libffi (which is not "linked"):
echo "Are we on Macos with Homebrew installed?"
brew --version >/dev/null 2>&1 && {
libffi_path="$(brew ls libffi | grep pkgconfig | xargs dirname)"
echo "Adding libffi pkg-config path ${libffi_path} to \$PKG_CONFIG_PATH"
export PKG_CONFIG_PATH="${libffi_path}:${PKG_CONFIG_PATH:-}"
}
echo "Are we on MSys (Windows)?"
uname -a | grep -q MSYS_NT && {
export PKG_CONFIG_PATH="/mingw64/lib/pkgconfig:${PKG_CONFIG_PATH:-}"
export PATH="/mingw64/bin:${PATH}"
}
(
# Do the whole installation process in a sub-shell, so we can safely fail when
# this file is sourced in the parent shell.
set -euo pipefail
check() {
echo Checking: $@
$@ >/dev/null 2>&1
}
NO_FORCE_INSTALL=true
while getopts 'fSh' OPTION
do
case "$OPTION" in
f)
NO_FORCE_INSTALL=false
;;
S)
VENV_OPTS="--system-site-packages"
;;
h) echo "Usage: $0 [-f] [-S] [-h] # -f = force install, -S = Use system site packages, -h = this message"
exit 0
esac
done
check python3 --version || {
echo "==> Python 3.x not found"
exit 1
}
check pkg-config --print-errors --exists 'gobject-introspection-1.0 >= 1.46.0' || {
echo "==> GObject-Introspection not found, Please check above errors and correct them"
exit 1
}
PYTHON_VER="$(python3 --version | sed 's/^Python \([0-9]\.[0-9]\).[0-9]$/\1/')"
test -d $SCRIPT_DIR/.venv || {
echo "Setting up a virtual env for Gaphor..."
python3 -m venv --prompt Gaphor ${VENV_OPTS:-} $SCRIPT_DIR/.venv
}
source $SCRIPT_DIR/.venv/bin/activate
{ ${NO_FORCE_INSTALL} && test -f $SCRIPT_DIR/.venv/lib/python${PYTHON_VER}/site-packages/gaphor.egg-link; } || {
echo "Installing Gaphor in the virtualenv..."
# Use 1.0.0b7 until https://github.com/python-poetry/poetry/issues/1880 is fixed
pip install --upgrade poetry==1.0.0b7
poetry config virtualenvs.create false
poetry install
}
test_module() {
python3 -c "$1" 2>&- || {
echo "$2"
echo
echo "The Command used to test this:"
echo
echo " >>> $1"
echo
exit 1
}
}
test_module \
"import gi" \
"PyGobject3 (gobject-introspection) can not be loaded"
test_module \
"from gi.repository import Gtk" \
"Gtk3 is not installed in a way it can be loaded in Python"
test_module \
"import gaphor.UML" \
"Gaphor was not installed properly, that should not have happened. Please open an issue on GitHub"
) && source $SCRIPT_DIR/.venv/bin/activate